"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageProcessor = void 0;
var fs_1 = __importDefault(require("fs"));
var os_1 = __importDefault(require("os"));
var path_1 = __importDefault(require("path"));
var crypto_1 = __importDefault(require("crypto"));
var mkdirp = require('mkdirp');
var imagemin = require('imagemin');
var imageminMozjpeg = require('imagemin-mozjpeg');
var resizer_1 = require("./resizer");
var OPTIMIZED_DIR = 'optimized';
var ImageProcessor = /** @class */ (function () {
    function ImageProcessor(tmpDir, log) {
        this.tmpRootDir = tmpDir !== null && tmpDir !== void 0 ? tmpDir : os_1.default.tmpdir();
        this.log = log !== null && log !== void 0 ? log : (function (ctx, msg) {
            console.log(msg, JSON.stringify(ctx, null, 2));
        });
    }
    /**
     * ./tmp/workNNNNN/
     *    <here resized files>
     *    optimzed/
     *       <here optimized files>
     */
    ImageProcessor.prototype.execute = function (fileStream, imageInfos, quality) {
        if (quality === void 0) { quality = 80; }
        return __awaiter(this, void 0, void 0, function () {
            var tmpDir, sortedImgInfos, maxImgInfo, maxImgFilePath, maxOutImgInfo, outImgInfos, _i, sortedImgInfos_1, imgInfo, destFilePath, _a, _b, results, _c, outImgInfos_1, outImgInfo, pathParts;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        tmpDir = path_1.default.join(this.tmpRootDir, 'work' + crypto_1.default.randomBytes(8).readUInt32LE(0));
                        mkdirp.sync(tmpDir + "/optimized");
                        if (imageInfos.length === 0) {
                            throw new Error('imageInfo requires at least 1 item');
                        }
                        sortedImgInfos = imageInfos.sort(function (a, b) { return (b.width * b.height - a.width * a.height); });
                        maxImgInfo = sortedImgInfos.shift();
                        maxImgFilePath = path_1.default.join(tmpDir, maxImgInfo.kind + ".jpg");
                        return [4 /*yield*/, this.generateArrangedFile(fileStream, maxImgFilePath, maxImgInfo)];
                    case 1:
                        maxOutImgInfo = _d.sent();
                        outImgInfos = [maxOutImgInfo];
                        _i = 0, sortedImgInfos_1 = sortedImgInfos;
                        _d.label = 2;
                    case 2:
                        if (!(_i < sortedImgInfos_1.length)) return [3 /*break*/, 5];
                        imgInfo = sortedImgInfos_1[_i];
                        destFilePath = path_1.default.join(tmpDir, imgInfo.kind + ".jpg");
                        _b = (_a = outImgInfos).push;
                        return [4 /*yield*/, this.generateScaledFile(maxImgFilePath, destFilePath, imgInfo)];
                    case 3:
                        _b.apply(_a, [_d.sent()]);
                        _d.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [4 /*yield*/, this.generateOptimizedFiles(tmpDir, path_1.default.join(tmpDir, OPTIMIZED_DIR), quality)
                        // Deleting sized files and build results
                    ];
                    case 6:
                        _d.sent();
                        results = [];
                        for (_c = 0, outImgInfos_1 = outImgInfos; _c < outImgInfos_1.length; _c++) {
                            outImgInfo = outImgInfos_1[_c];
                            fs_1.default.unlink(outImgInfo.filePath, function () { }); // not wait
                            pathParts = outImgInfo.filePath.split('/');
                            pathParts.splice(pathParts.length - 1, 0, OPTIMIZED_DIR);
                            results.push({
                                kind: outImgInfo.kind,
                                format: 'jpeg',
                                width: outImgInfo.width,
                                height: outImgInfo.height,
                                filePath: pathParts.join('/')
                            });
                        }
                        this.log({}, 'Deleted scaled and unoptimized image files');
                        return [2 /*return*/, results];
                }
            });
        });
    };
    // convert file stream to maximum rotation arraged file
    ImageProcessor.prototype.generateArrangedFile = function (fileStream, destFilePath, imgInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var outImgInfo, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, resizer_1.convertStreamToArrangedFile(fileStream, destFilePath, imgInfo.width, imgInfo.height)];
                    case 1:
                        outImgInfo = _a.sent();
                        result = __assign(__assign({}, outImgInfo), { kind: imgInfo.kind, filePath: destFilePath });
                        this.log(result, 'Generated maximum scaled image file');
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ImageProcessor.prototype.generateScaledFile = function (srcFilePath, destFilePath, imgInfo) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var outImgInfo, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, resizer_1.convertToScaledFile(srcFilePath, destFilePath, (_a = imgInfo.crop) !== null && _a !== void 0 ? _a : false, imgInfo.width, imgInfo.height)];
                    case 1:
                        outImgInfo = _b.sent();
                        result = __assign(__assign({}, outImgInfo), { kind: imgInfo.kind, filePath: destFilePath });
                        this.log(result, 'Generated scaled image file from maximum scaled one');
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ImageProcessor.prototype.generateOptimizedFiles = function (srcDir, destDir, quality) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, imagemin([srcDir + "/*.jpg"], {
                            destination: destDir,
                            plugins: [imageminMozjpeg({ quality: quality })]
                        })];
                    case 1:
                        _a.sent();
                        this.log({}, 'Generated optimized image files');
                        return [2 /*return*/];
                }
            });
        });
    };
    return ImageProcessor;
}());
exports.ImageProcessor = ImageProcessor;
